var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { InMemoryCache } from '@apollo/client/cache/index.js';
import { ApolloClient } from '@apollo/client/core/index.js';
import { createHttpLink } from '@apollo/client/link/http/index.js';
import { Module } from '@nestjs/common';
import { fetch } from 'cross-fetch';
import { ApolloRenderMiddleware } from 'express-tsx-views/dist/apollo.js';
import { fileURLToPath, URL } from 'node:url';
import { resolve } from 'path';
import { TsxViewsModule } from '../../index.js';
import { AppController } from './app.controller.js';
const dirname = fileURLToPath(new URL('.', import.meta.url));
export let AppModule = class AppModule {
};
AppModule = __decorate([
    Module({
        imports: [
            TsxViewsModule.registerAsync({
                useFactory: (apollo) => ({
                    viewsDirectory: resolve(dirname, './views'),
                    prettify: true,
                    exclude: ['/throws-exception'],
                    forRoutes: [AppController],
                    middlewares: [new ApolloRenderMiddleware(apollo)],
                }),
                inject: [ApolloClient],
                extraProviders: [
                    {
                        provide: ApolloClient,
                        useValue: new ApolloClient({
                            ssrMode: true,
                            link: createHttpLink({
                                uri: 'https://swapi-graphql.netlify.app/.netlify/functions/index',
                                fetch,
                            }),
                            cache: new InMemoryCache(),
                        }),
                    },
                ],
            }),
        ],
        controllers: [AppController],
    })
], AppModule);
//# sourceMappingURL=app.module.js.map